//----------------------------------------------------------------------------------
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! SixPak Script Pack !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//----------------------------------------------------------------------------------
// FILE NAME    | load_huds.cs
// AUTHOR       | SixStringz  
// AUTHOR EMAIL | mccleans@inreach.com
// VERSION      | 1.7
// RELEASE DATE | 9/13/99
// REQUIREMENTS | SixPak
// DESCRIPTION  | Load HUDs to be positioned by HUDSets.cs or a default setup
// DESCRIPTION  | if HUDSets is disabled.
// DESCRIPTION  | 
//----------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------------------------

Six::SetResString();

if($SixPref::HUDConfig=="")	
   if ($SixVar::Res != "640x480") 
      $SixPref::HUDConfig = 2;
   else
      $SixPref::HUDConfig = 1;

if($SixPref::HUDConfig >="6")	$SixPref::HUDConfig = 2;


function Six::LoadHUDSets()
{
   if ($SixPref::HUDConfig == 1)
   {
      echo("Loading scripts for HUD config #1");
      include("six\\sixhud.cs");
      if ($SixVar::Res != "640x480")
         include("six\\scorehud.cs");
      include("six\\pinghud.cs");
   }
   else if ($SixPref::HUDConfig == 2)
   {
      echo("Loading scripts for HUD config #2"); 
      include("six\\sixhud.cs");
      include("cowboy\\FlagCapsHUD.cs");
      if ($SixVar::Res != "640x480") 
         include("six\\scorehud.cs");
      include("six\\dropTimer.cs");
      include("six\\pinghud.cs");
   }
   else if ($SixPref::HUDConfig == 3)
   {
      echo("Loading scripts for HUD config #3"); 
      include("six\\sixhud.cs");
      include("Crunchy\\ObjectiveHUD.cs");
      include("cowboy\\FlagCapsHUD.cs");
      include("six\\dropTimer.cs");
      include("six\\pinghud.cs");
   }
   else if ($SixPref::HUDConfig == 4)
   {
      echo("Loading scripts for HUD config #4");
      include("Crunchy\\ObjectiveHUD.cs");
      include("Crunchy\\ItemHUD.cs");
      include("Crunchy\\TeamSizeHUD.cs");
      include("cowboy\\FlagCapsHUD.cs");
      include("six\\TinyCapHUD.cs");
      include("six\\TinyKillHUD.cs");
      include("cowboy\\cowboyhud.cs");
      include("six\\dropTimer.cs");
      include("six\\pinghud.cs");
   }
   else if ($SixPref::HUDConfig == 5)
   {
      echo("Loading scripts for HUD config #5");
      include("Crunchy\\ItemHUD.cs");
      Include("six\\FlagHunterHUD.cs");
      include("six\\pinghud.cs");
   }
}

function Six::LoadNoSets()
{
   echo("Loading scripts for HUD config #0 -No HUDSet-"); 
   include("six\\sixhud.cs");
   if ($SixVar::Res != "640x480") 
   {
      include("six\\scorehud.cs");
      include("cowboy\\FlagCapsHUD.cs");
   }
   include("six\\dropTimer.cs");
}

if($SixPref::HUDConfig)	
   Six::LoadHUDSets();
else
   Six::LoadNoSets();